Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Resources
Imports System.Data
Imports CADImport.FaceModule
Imports CADImport.CADImportControls
Imports CADImport.CADImportForms

Public Class MainForm
    Inherits Form
    ' Methods
    Public Sub New()
        Me.InitializeComponent()
        Me.InitializeSettings()
    End Sub

    <System.STAThread()> _
    Public Shared Sub Main()
        Application.EnableVisualStyles()
        Application.DoEvents()
        Application.Run(New MainForm)
    End Sub

    Private Sub cadEditorControl_EndLoadFile(ByVal val As Boolean)
        If val Then
            Me.EnableMenuItems(True)
        End If
    End Sub

    Private Sub ChangeBackground()
        Me.miWhiteBack.Checked = Me.whiteBackGround
        Me.miBlackBack.Checked = Me.blackBackGround
        If Me.whiteBackGround Then
            Me.cadEditorControl.SetWhiteBackGround()
        End If
        If Me.blackBackGround Then
            Me.cadEditorControl.SetBlackBackGround()
        End If
    End Sub

    Private Sub ChangeControlState(ByVal val As Boolean)
        Me.miTextsShow.Checked = Me.cadEditorControl.TextVisible
        Me.miDimShow.Checked = Me.cadEditorControl.DimensionVisible
        Me.miShowLineWeight.Checked = Me.cadEditorControl.ShowLineWeight
        Dim colorblack As Boolean = Me.cadEditorControl.Image.BackgroundColor.Equals(Color.Black)
        Me.miBlackBack.Checked = colorblack
        Me.miWhiteBack.Checked = Not colorblack
        Me.miShowEntitiesPanel.Checked = Me.cadEditorControl.EntityTreeVisible
        Me.miColorMode.Checked = Me.cadEditorControl.ColorDraw
        Me.miBlackMode.Checked = Not Me.cadEditorControl.ColorDraw
    End Sub

    Public Sub ChangeLanguage(ByVal val As String, ByVal index As Integer)
        Me.curLngIndex = index
        Me.lngFile = (val & ApplicationConstants.lngextstr)
        Me.cadEditorControl.SetAllFormsLanguageSettings(Me.mlng.Path, Me.lngFile)
        Me.SetLNG()
        Me.cadEditorControl.ChangeControlState()
    End Sub

    Private Sub CreateNewSettingsList()
        Dim tmp As String
        MainForm.settingsLst = New SortedList
        MainForm.settingsLst.Add(ApplicationConstants.languagepath, Me.mlng.Path)
        MainForm.settingsLst.Add(ApplicationConstants.languagestr, Me.lngFile)
        MainForm.settingsLst.Add(ApplicationConstants.languageIDstr, Me.curLngIndex)
        If (Me.cadEditorControl.EditorCADPictureBox.BackColor.Equals(Color.Black)) Then
            tmp = ApplicationConstants.blackstr
        Else
            tmp = ApplicationConstants.whitestr
        End If
        MainForm.settingsLst.Add(ApplicationConstants.backcolorstr, tmp)
        MainForm.settingsLst.Add(ApplicationConstants.showentitystr, Me.cadEditorControl.EntityTreeVisible)
        If (Not Me.cadEditorControl.Image Is Nothing) Then
            MainForm.settingsLst.Add(ApplicationConstants.colorDraw, (Me.cadEditorControl.Image.DrawMode = CADImport.CADDrawMode.Normal))
        Else
            MainForm.settingsLst.Add(ApplicationConstants.colorDraw, Me.cadEditorControl.ColorDraw)
        End If
        Dim cn As Integer = Me.cadEditorControl.SHXForm.lstDir.Items.Count
        MainForm.settingsLst.Add(ApplicationConstants.shxpathcnstr, Me.cadEditorControl.SHXForm.lstDir.Items.Count)
        Dim i As Integer
        For i = 0 To cn - 1
            MainForm.settingsLst.Add(("SHXPath_" & (i + 1)), Me.cadEditorControl.SHXForm.lstDir.Items.Item(i))
        Next i
        Me.cadEditorControl.NewProtectionSettings(MainForm.settingsLst)
    End Sub

    Protected Overloads Sub Dispose(ByVal disposing As Boolean)
        If (disposing AndAlso (Not Me.components Is Nothing)) Then
            Me.components.Dispose()
        End If
        MyBase.Dispose(disposing)
    End Sub

    Public Sub EnableMenuItems(ByVal val As Boolean)
        Me.miSaveAsDXF.Enabled = val
        Me.miScale.Enabled = val
        Me.miSaveFile.Enabled = val
        Me.miCopyAsBMP.Enabled = val
        Me.miZoomIn.Enabled = val
        Me.miZoomOut.Enabled = val
        Me.miFit.Enabled = val
        Me.miColorMode.Enabled = val
        Me.miBlackMode.Enabled = val
        Me.miWhiteBack.Enabled = val
        Me.miBlackBack.Enabled = val
        Me.miShowLineWeight.Enabled = val
        Me.miArcsSplit.Enabled = val
        Me.miDimShow.Enabled = val
        Me.miTextsShow.Enabled = val
        Me.miLayersShow.Enabled = val
        Me.miClose.Enabled = val
        Me.miPrint.Enabled = val
        Me.miPrintCustom.Enabled = val
        Me.miPrintPrev.Enabled = val
        Me.miUndo.Enabled = val
        Me.miRedo.Enabled = val
        Me.miDelete.Enabled = val
        Me.miCopy.Enabled = val
        Me.miPaste.Enabled = val
        Me.miCut.Enabled = val
    End Sub

#Region " Windows Form Designer generated code "
    Private Sub InitializeComponent()
        Dim resources As New ResourceManager(GetType(MainForm))
        Me.mainMenu = New mainMenu
        Me.miFile = New MenuItem
        Me.miOpenFile = New MenuItem
        Me.miSaveFile = New MenuItem
        Me.miSaveAsDXF = New MenuItem
        Me.miPrint = New MenuItem
        Me.miPrintCustom = New MenuItem
        Me.miPrintPrev = New MenuItem
        Me.miClose = New MenuItem
        Me.miSep = New MenuItem
        Me.miExit = New MenuItem
        Me.editMenuItem = New MenuItem
        Me.miCopyAsBMP = New MenuItem
        Me.miUndo = New MenuItem
        Me.miRedo = New MenuItem
        Me.miDelete = New MenuItem
        Me.miCopy = New MenuItem
        Me.miCut = New MenuItem
        Me.miPaste = New MenuItem
        Me.miView = New MenuItem
        Me.miShowEntitiesPanel = New MenuItem
        Me.miSep5 = New MenuItem
        Me.miZoomIn = New MenuItem
        Me.miZoomOut = New MenuItem
        Me.miScale = New MenuItem
        Me.miZoom10 = New MenuItem
        Me.miZoom25 = New MenuItem
        Me.miZoom50 = New MenuItem
        Me.miZoom100 = New MenuItem
        Me.miZoom200 = New MenuItem
        Me.miZoom400 = New MenuItem
        Me.miZoom800 = New MenuItem
        Me.miFit = New MenuItem
        Me.mSep4 = New MenuItem
        Me.miShowSHXForm = New MenuItem
        Me.miShowOptionsForm = New MenuItem
        Me.miCADFiles = New MenuItem
        Me.miColorMode = New MenuItem
        Me.miBlackMode = New MenuItem
        Me.miWhiteBack = New MenuItem
        Me.miBlackBack = New MenuItem
        Me.miSep2 = New MenuItem
        Me.miShowLineWeight = New MenuItem
        Me.miArcsSplit = New MenuItem
        Me.miDimShow = New MenuItem
        Me.miTextsShow = New MenuItem
        Me.miSep3 = New MenuItem
        Me.miLayersShow = New MenuItem
        Me.miHelp = New MenuItem
        Me.miLng = New MenuItem
        Me.miRegister = New MenuItem
        Me.miFloatLic = New MenuItem
        Me.miAbout = New MenuItem
        Me.cadEditorControl = New cadEditorControl
        MyBase.SuspendLayout()
        Me.mainMenu.MenuItems.AddRange(New MenuItem() {Me.miFile, Me.editMenuItem, Me.miView, Me.miCADFiles, Me.miHelp})
        Me.miFile.Index = 0
        Me.miFile.MenuItems.AddRange(New MenuItem() {Me.miOpenFile, Me.miSaveFile, Me.miSaveAsDXF, Me.miPrint, Me.miPrintCustom, Me.miPrintPrev, Me.miClose, Me.miSep, Me.miExit})
        Me.miFile.Text = "&File"
        Me.miOpenFile.Index = 0
        Me.miOpenFile.Text = "Open Picture..."
        AddHandler Me.miOpenFile.Click, New EventHandler(AddressOf Me.miOpenFile_Click)
        Me.miSaveFile.Enabled = False
        Me.miSaveFile.Index = 1
        Me.miSaveFile.Text = "Save Picture..."
        AddHandler Me.miSaveFile.Click, New EventHandler(AddressOf Me.miSaveFile_Click)
        Me.miSaveAsDXF.Enabled = False
        Me.miSaveAsDXF.Index = 2
        Me.miSaveAsDXF.Text = "Save as DXF..."
        AddHandler Me.miSaveAsDXF.Click, New EventHandler(AddressOf Me.miSaveAsDXF_Click)
        Me.miPrint.Enabled = False
        Me.miPrint.Index = 3
        Me.miPrint.Text = "Print "
        AddHandler Me.miPrint.Click, New EventHandler(AddressOf Me.miPrint_Click)
        Me.miPrintCustom.Enabled = False
        Me.miPrintCustom.Index = 4
        Me.miPrintCustom.Text = "Custom Print Preview..."
        AddHandler Me.miPrintCustom.Click, New EventHandler(AddressOf Me.miPrintCustom_Click)
        Me.miPrintPrev.Enabled = False
        Me.miPrintPrev.Index = 5
        Me.miPrintPrev.Text = "Print Preview..."
        AddHandler Me.miPrintPrev.Click, New EventHandler(AddressOf Me.miPrintPrev_Click)
        Me.miClose.Enabled = False
        Me.miClose.Index = 6
        Me.miClose.Text = "Close Picture"
        AddHandler Me.miClose.Click, New EventHandler(AddressOf Me.miClose_Click)
        Me.miSep.Index = 7
        Me.miSep.Text = "-"
        Me.miExit.Index = 8
        Me.miExit.Text = "Close"
        AddHandler Me.miExit.Click, New EventHandler(AddressOf Me.miExit_Click)
        Me.editMenuItem.Index = 1
        Me.editMenuItem.MenuItems.AddRange(New MenuItem() {Me.miCopyAsBMP, Me.miUndo, Me.miRedo, Me.miDelete, Me.miCopy, Me.miCut, Me.miPaste})
        Me.editMenuItem.Text = "&Edit"
        Me.miCopyAsBMP.Enabled = False
        Me.miCopyAsBMP.Index = 0
        Me.miCopyAsBMP.Text = "Copy as BMP"
        AddHandler Me.miCopyAsBMP.Click, New EventHandler(AddressOf Me.miCopyAsBMP_Click)
        Me.miUndo.Enabled = False
        Me.miUndo.Index = 1
        Me.miUndo.Shortcut = Shortcut.CtrlZ
        Me.miUndo.Text = "Undo"
        AddHandler Me.miUndo.Click, New EventHandler(AddressOf Me.miUndo_Click)
        Me.miRedo.Enabled = False
        Me.miRedo.Index = 2
        Me.miRedo.Shortcut = Shortcut.CtrlY
        Me.miRedo.Text = "Redo"
        AddHandler Me.miRedo.Click, New EventHandler(AddressOf Me.miRedo_Click)
        Me.miDelete.Enabled = False
        Me.miDelete.Index = 3
        Me.miDelete.Shortcut = Shortcut.Del
        Me.miDelete.Text = "Delete"
        AddHandler Me.miDelete.Click, New EventHandler(AddressOf Me.miDelete_Click)
        Me.miCopy.Enabled = False
        Me.miCopy.Index = 4
        Me.miCopy.Shortcut = Shortcut.CtrlC
        Me.miCopy.Text = "&Copy"
        AddHandler Me.miCopy.Click, New EventHandler(AddressOf Me.miCopy_Click)
        Me.miCut.Enabled = False
        Me.miCut.Index = 5
        Me.miCut.Shortcut = Shortcut.CtrlX
        Me.miCut.Text = "Cu&t"
        AddHandler Me.miCut.Click, New EventHandler(AddressOf Me.miCut_Click)
        Me.miPaste.Enabled = False
        Me.miPaste.Index = 6
        Me.miPaste.Shortcut = Shortcut.CtrlV
        Me.miPaste.Text = "Paste"
        AddHandler Me.miPaste.Click, New EventHandler(AddressOf Me.miPaste_Click)
        Me.miView.Index = 2
        Me.miView.MenuItems.AddRange(New MenuItem() {Me.miShowEntitiesPanel, Me.miSep5, Me.miZoomIn, Me.miZoomOut, Me.miScale, Me.miFit, Me.mSep4, Me.miShowSHXForm, Me.miShowOptionsForm})
        Me.miView.Text = "&View"
        Me.miShowEntitiesPanel.Checked = True
        Me.miShowEntitiesPanel.Index = 0
        Me.miShowEntitiesPanel.Text = "Show entities panel"
        AddHandler Me.miShowEntitiesPanel.Click, New EventHandler(AddressOf Me.miShowEntitiesPanel_Click)
        Me.miSep5.Index = 1
        Me.miSep5.Text = "-"
        Me.miZoomIn.Enabled = False
        Me.miZoomIn.Index = 2
        Me.miZoomIn.Text = "Zoom In (+)"
        AddHandler Me.miZoomIn.Click, New EventHandler(AddressOf Me.miZoomIn_Click)
        Me.miZoomOut.Enabled = False
        Me.miZoomOut.Index = 3
        Me.miZoomOut.Text = "Zoom Out (-)"
        AddHandler Me.miZoomOut.Click, New EventHandler(AddressOf Me.miZoomOut_Click)
        Me.miScale.Enabled = False
        Me.miScale.Index = 4
        Me.miScale.MenuItems.AddRange(New MenuItem() {Me.miZoom10, Me.miZoom25, Me.miZoom50, Me.miZoom100, Me.miZoom200, Me.miZoom400, Me.miZoom800})
        Me.miScale.Text = "Scale"
        Me.miZoom10.Index = 0
        Me.miZoom10.Text = "10%"
        AddHandler Me.miZoom10.Click, New EventHandler(AddressOf Me.miZoom_Click)
        Me.miZoom25.Index = 1
        Me.miZoom25.Text = "25%"
        AddHandler Me.miZoom25.Click, New EventHandler(AddressOf Me.miZoom_Click)
        Me.miZoom50.Index = 2
        Me.miZoom50.Text = "50%"
        AddHandler Me.miZoom50.Click, New EventHandler(AddressOf Me.miZoom_Click)
        Me.miZoom100.Index = 3
        Me.miZoom100.Text = "100%"
        AddHandler Me.miZoom100.Click, New EventHandler(AddressOf Me.miZoom_Click)
        Me.miZoom200.Index = 4
        Me.miZoom200.Text = "200%"
        AddHandler Me.miZoom200.Click, New EventHandler(AddressOf Me.miZoom_Click)
        Me.miZoom400.Index = 5
        Me.miZoom400.Text = "400%"
        AddHandler Me.miZoom400.Click, New EventHandler(AddressOf Me.miZoom_Click)
        Me.miZoom800.Index = 6
        Me.miZoom800.Text = "800%"
        AddHandler Me.miZoom800.Click, New EventHandler(AddressOf Me.miZoom_Click)
        Me.miFit.Enabled = False
        Me.miFit.Index = 5
        Me.miFit.Text = "Fit drawing to window"
        AddHandler Me.miFit.Click, New EventHandler(AddressOf Me.miFit_Click)
        Me.mSep4.Index = 6
        Me.mSep4.Text = "-"
        Me.miShowSHXForm.Index = 7
        Me.miShowSHXForm.Text = "SHX Fonts"
        AddHandler Me.miShowSHXForm.Click, New EventHandler(AddressOf Me.miShowSHXForm_Click)
        Me.miShowOptionsForm.Index = 8
        Me.miShowOptionsForm.Text = "Options"
        AddHandler Me.miShowOptionsForm.Click, New EventHandler(AddressOf Me.miOptions_Click)
        Me.miCADFiles.Index = 3
        Me.miCADFiles.MenuItems.AddRange(New MenuItem() {Me.miColorMode, Me.miBlackMode, Me.miWhiteBack, Me.miBlackBack, Me.miSep2, Me.miShowLineWeight, Me.miArcsSplit, Me.miDimShow, Me.miTextsShow, Me.miSep3, Me.miLayersShow})
        Me.miCADFiles.Text = "&CAD files"
        Me.miColorMode.Checked = True
        Me.miColorMode.Enabled = False
        Me.miColorMode.Index = 0
        Me.miColorMode.RadioCheck = True
        Me.miColorMode.Text = "Color drawing"
        AddHandler Me.miColorMode.Click, New EventHandler(AddressOf Me.miColorMode_Click)
        Me.miBlackMode.Enabled = False
        Me.miBlackMode.Index = 1
        Me.miBlackMode.RadioCheck = True
        Me.miBlackMode.Text = "Black drawing"
        AddHandler Me.miBlackMode.Click, New EventHandler(AddressOf Me.miBlackMode_Click)
        Me.miWhiteBack.Enabled = False
        Me.miWhiteBack.Index = 2
        Me.miWhiteBack.RadioCheck = True
        Me.miWhiteBack.Text = "White Background"
        AddHandler Me.miWhiteBack.Click, New EventHandler(AddressOf Me.miWhiteBack_Click)
        Me.miBlackBack.Checked = True
        Me.miBlackBack.Enabled = False
        Me.miBlackBack.Index = 3
        Me.miBlackBack.RadioCheck = True
        Me.miBlackBack.Text = "Black Background"
        AddHandler Me.miBlackBack.Click, New EventHandler(AddressOf Me.miBlackBack_Click)
        Me.miSep2.Enabled = False
        Me.miSep2.Index = 4
        Me.miSep2.Text = "-"
        Me.miShowLineWeight.Checked = True
        Me.miShowLineWeight.Enabled = False
        Me.miShowLineWeight.Index = 5
        Me.miShowLineWeight.Text = "Show Lineweight"
        AddHandler Me.miShowLineWeight.Click, New EventHandler(AddressOf Me.miShowLineWeight_Click)
        Me.miArcsSplit.Checked = True
        Me.miArcsSplit.Enabled = False
        Me.miArcsSplit.Index = 6
        Me.miArcsSplit.Text = "Arcs Splitted"
        AddHandler Me.miArcsSplit.Click, New EventHandler(AddressOf Me.miArcsSplit_Click)
        Me.miDimShow.Checked = True
        Me.miDimShow.Enabled = False
        Me.miDimShow.Index = 7
        Me.miDimShow.Text = "Dimensions Show"
        AddHandler Me.miDimShow.Click, New EventHandler(AddressOf Me.miDimShow_Click)
        Me.miTextsShow.Checked = True
        Me.miTextsShow.Enabled = False
        Me.miTextsShow.Index = 8
        Me.miTextsShow.Text = "Texts Show"
        AddHandler Me.miTextsShow.Click, New EventHandler(AddressOf Me.miTextsShow_Click)
        Me.miSep3.Enabled = False
        Me.miSep3.Index = 9
        Me.miSep3.Text = "-"
        Me.miLayersShow.Enabled = False
        Me.miLayersShow.Index = 10
        Me.miLayersShow.Text = "Show Layers"
        AddHandler Me.miLayersShow.Click, New EventHandler(AddressOf Me.miLayersShow_Click)
        Me.miHelp.Index = 4
        Me.miHelp.MenuItems.AddRange(New MenuItem() {Me.miLng, Me.miRegister, Me.miFloatLic, Me.miAbout})
        Me.miHelp.Text = "?"
        Me.miLng.Index = 0
        Me.miLng.Text = "Language"
        Me.miRegister.Index = 1
        Me.miRegister.Text = "Register "
        AddHandler Me.miRegister.Click, New EventHandler(AddressOf Me.miRegister_Click)
        Me.miFloatLic.Index = 2
        Me.miFloatLic.Text = "Floating License Registration..."
        AddHandler Me.miFloatLic.Click, New EventHandler(AddressOf Me.miFloatLic_Click)
        Me.miAbout.Index = 3
        Me.miAbout.Text = "About..."
        AddHandler Me.miAbout.Click, New EventHandler(AddressOf Me.miAbout_Click)
        Me.cadEditorControl.ColorDraw = True
        Me.cadEditorControl.DimensionVisible = True
        Me.cadEditorControl.Dock = DockStyle.Fill
        Me.cadEditorControl.EnableSnap = True
        Me.cadEditorControl.EndPoint = New Point(0, 0)
        Me.cadEditorControl.EntityPropertyGridVisible = True
        Me.cadEditorControl.EntityTreeVisible = True
        Me.cadEditorControl.ImageBaseSize = DirectCast(resources.GetObject("cadEditorControl.ImageBaseSize"), SizeF)
        Me.cadEditorControl.ImagePosition = DirectCast(resources.GetObject("cadEditorControl.ImagePosition"), PointF)
        Me.cadEditorControl.ImageScale = 1.0!
        Me.cadEditorControl.InFileName = ""
        Me.cadEditorControl.Location = New Point(0, 0)
        Me.cadEditorControl.Name = "cadEditorControl"
        Me.cadEditorControl.OutFileName = ""
        Me.cadEditorControl.PreviousImagePosition = DirectCast(resources.GetObject("cadEditorControl.PreviousImagePosition"), PointF)
        Me.cadEditorControl.PreviousImageScale = 1.0!
        Me.cadEditorControl.PropertyEntityPanelVisible = True
        Me.cadEditorControl.ShowLineWeight = True
        Me.cadEditorControl.Size = New Size(&H278, &H1CE)
        Me.cadEditorControl.StartPoint = New Point(0, 0)
        Me.cadEditorControl.StatusBarPanelVisible = True
        Me.cadEditorControl.TabIndex = 0
        Me.cadEditorControl.TextVisible = True
        Me.cadEditorControl.ToolsPanelVisible = True
        AddHandler Me.cadEditorControl.EndLoadFile, New ChangeOptionsEventHandler(AddressOf Me.cadEditorControl_EndLoadFile)
        Me.AutoScaleBaseSize = New Size(5, 13)
        MyBase.ClientSize = New Size(&H278, &H1CE)
        MyBase.Controls.Add(Me.cadEditorControl)
        MyBase.Menu = Me.mainMenu
        MyBase.Name = "MainForm"
        Me.Text = "Editor"
        AddHandler MyBase.Closing, New CancelEventHandler(AddressOf Me.MainForm_Closing)
        MyBase.ResumeLayout(False)
    End Sub
#End Region

    Private Sub InitializeSettings()
        Me.dimVisible = True
        Me.useWinEllipse = False
        Me.showLineWeight = True
        Me.whiteBackGround = False
        Me.blackBackGround = True
        Me.propPnVisible = True
        Me.textVisible = True
        Me.svSet = New SaveSettings(MainForm.fileSettingsName)
        MainForm.settingsLst = Me.svSet.LoadOptions
        Me.lngFile = ApplicationConstants.defaultstr
        Me.curLngIndex = 0
        Me.InitLng()
        If (MainForm.settingsLst Is Nothing) Then
            Me.CreateNewSettingsList()
        Else
            Me.SetSettings()
        End If
        Me.ReloadLNG()
        If (Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Count > Me.curLngIndex) Then
            Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Item(Me.curLngIndex).Checked = True
        End If
        Me.SetAllFormsSettings()
        AddHandler Me.cadEditorControl.ChangeTextShow, New ChangeOptionsEventHandler(AddressOf Me.ChangeControlState)
        AddHandler Me.cadEditorControl.ChangeDimensionShow, New ChangeOptionsEventHandler(AddressOf Me.ChangeControlState)
        AddHandler Me.cadEditorControl.ChangeLineWeightShow, New ChangeOptionsEventHandler(AddressOf Me.ChangeControlState)
        AddHandler Me.cadEditorControl.ChangeBackgroundColor, New ChangeOptionsEventHandler(AddressOf Me.ChangeControlState)
    End Sub

    Private Sub InitLng()
        Me.mlng = New MultipleLanguage(MyBase.GetType)
        If (Not Me.mainMenu Is Nothing) Then
            Me.mlng.SaveNameMenuItem(Me.mainMenu.MenuItems)
        End If
        If (Not Me.ContextMenu Is Nothing) Then
            Me.mlng.SaveNameMenuItem(Me.ContextMenu.MenuItems)
        End If
        Me.mlng.SaveNameNoNameElement(MyBase.Controls)
    End Sub

    Private Sub InitSettings()
        Me.svSet = New SaveSettings(MainForm.fileSettingsName)
        MainForm.settingsLst = Me.svSet.LoadOptions
        If (Not MainForm.settingsLst Is Nothing) Then
            Dim key As String = ApplicationConstants.languagepath
            If MainForm.settingsLst.ContainsKey(key) Then
                Me.mlng.Path = Convert.ToString(MainForm.settingsLst.Item(key))
            End If
        Else
            Me.mlng.Path = ".\Languages"
        End If
        Me.mlng.LoadLngFileList(Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0), New EventHandler(AddressOf Me.LanguageSelect_Click))
        If (MainForm.settingsLst Is Nothing) Then
            Me.CreateNewSettingsList()
        Else
            Me.SetSettings()
        End If
    End Sub

    Private Sub LanguageSelect_Click(ByVal sender As Object, ByVal e As EventArgs)
        If TypeOf sender Is MenuItem Then
            Dim mn As MenuItem = CType(sender, MenuItem)
            Me.curLngIndex = CByte(mn.Index)
            Me.lngFile = (mn.Text & ApplicationConstants.lngextstr)
            Me.cadEditorControl.SetAllFormsLanguageSettings(Me.mlng.Path, Me.lngFile)
            Me.SetLNG()
            Me.cadEditorControl.ChangeControlState()
        End If
    End Sub

    Private Sub MainForm_Closing(ByVal sender As Object, ByVal e As CancelEventArgs)
        Me.CreateNewSettingsList()
        Me.svSet.SaveOptions(MainForm.settingsLst)
    End Sub

    Private Sub miAbout_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.AboutForm.ShowDialog()
    End Sub

    Private Sub miArcsSplit_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.useWinEllipse = Not Me.useWinEllipse
        Me.cadEditorControl.UseWinEllipse(Me.useWinEllipse)
        Me.miArcsSplit.Checked = Not Me.useWinEllipse
    End Sub

    Private Sub miBlackBack_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.whiteBackGround = False
        Me.blackBackGround = True
        Me.ChangeBackground()
    End Sub

    Private Sub miBlackMode_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.ColorDraw = False
        Me.miColorMode.Checked = False
        Me.miBlackMode.Checked = True
    End Sub

    Private Sub miClose_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.CloseFile()
    End Sub

    Private Sub miColorMode_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.ColorDraw = True
        Me.miColorMode.Checked = True
        Me.miBlackMode.Checked = False
    End Sub

    Private Sub miCopy_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.Image.CopyEntities()
    End Sub

    Private Sub miCopyAsBMP_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.PutToClipboard()
    End Sub

    Private Sub miCut_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.Image.CutEntities()
        Me.cadEditorControl.EditorCADPictureBox.Invalidate()
    End Sub

    Private Sub miDelete_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.DeleteSelectedEntities()
    End Sub

    Private Sub miDimShow_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.dimVisible = Not Me.dimVisible
        Me.cadEditorControl.DimensionVisible = Me.dimVisible
        Me.miDimShow.Checked = Me.dimVisible
    End Sub

    Private Sub miExit_Click(ByVal sender As Object, ByVal e As EventArgs)
        MyBase.Close()
    End Sub

    Private Sub miFit_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.CalculateNewSizeImage()
    End Sub

    Private Sub miFloatLic_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.FloatLicForm.ShowDialog()
    End Sub

    Private Sub miLayersShow_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.LayerForm.ShowDialog()
    End Sub

    Private Sub miOpenFile_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.LoadFile(True)
    End Sub

    Private Sub miOptions_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.EntitiesCreator.OptionsForm.ShowDialog()
    End Sub

    Private Sub miPaste_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.Image.PasteEntities()
        Me.cadEditorControl.EditorCADPictureBox.Invalidate()
    End Sub

    Private Sub miPrint_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.Image.Print(True, True)
    End Sub

    Private Sub miPrintCustom_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.ShowCustomPrintPreviewDialog()
    End Sub

    Private Sub miPrintPrev_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.ShowPrintPreviewDialog()
    End Sub

    Private Sub miRedo_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.RedoChangeEntity()
    End Sub

    Private Sub miRegister_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.RegForm.ShowDialog()
    End Sub

    Private Sub miSaveAsDXF_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.SaveAsDXF(True)
    End Sub

    Private Sub miSaveFile_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.SaveAsImage(True)
    End Sub

    Private Sub miShowEntitiesPanel_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.propPnVisible = Not Me.propPnVisible
        Me.cadEditorControl.PropertyEntityPanelVisible = Me.propPnVisible
        Me.miShowEntitiesPanel.Checked = Me.propPnVisible
    End Sub

    Private Sub miShowLineWeight_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.showLineWeight = Not Me.showLineWeight
        Me.cadEditorControl.ShowLineWeight = Me.showLineWeight
        Me.miShowLineWeight.Checked = Me.showLineWeight
    End Sub

    Private Sub miShowSHXForm_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.SHXForm.ShowDialog()
    End Sub

    Private Sub miTextsShow_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.textVisible = Not Me.textVisible
        Me.cadEditorControl.TextVisible = Me.textVisible
        Me.miTextsShow.Checked = Me.textVisible
    End Sub

    Private Sub miUndo_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.UndoChangeEntity()
    End Sub

    Private Sub miWhiteBack_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.whiteBackGround = True
        Me.blackBackGround = False
        Me.ChangeBackground()
    End Sub

    Private Sub miZoom_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim i As Single = 1.0!
        Select Case CType(sender, MenuItem).Index
            Case 0
                i = 0.1!
                Exit Select
            Case 1
                i = 0.25!
                Exit Select
            Case 2
                i = 0.5!
                Exit Select
            Case 3
                i = 1.0!
                Exit Select
            Case 4
                i = 2.0!
                Exit Select
            Case 5
                i = 4.0!
                Exit Select
            Case 6
                i = 8.0!
                Exit Select
        End Select
        Me.cadEditorControl.SetScale(i)
    End Sub

    Private Sub miZoomIn_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.DoZoomIn()
    End Sub

    Private Sub miZoomOut_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.cadEditorControl.DoZoomOut()
    End Sub

    Friend Sub ReloadLNG()
        Me.mlng.LoadLngFileList(Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0), New EventHandler(AddressOf Me.LanguageSelect_Click))
    End Sub

    Friend Sub ReloadLNG(ByVal val As String)
        Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Clear()
        Me.mlng.Path = val
        Me.mlng.LoadLngFileList(Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0), New EventHandler(AddressOf Me.LanguageSelect_Click))
        If (Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Count > Me.curLngIndex) Then
            Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Item(Me.curLngIndex).Checked = True
        End If
    End Sub

    Private Sub SelectLanguage()
        Dim i As Integer
        For i = 0 To Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Count - 1
            If (Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Item(i).Text = "English") Then
                Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Item(i).Checked = True
                Me.curLngIndex = i
                Exit For
            End If
        Next i
    End Sub

    Private Sub SetAllFormsSettings()
        Me.cadEditorControl.SetAllFormsLanguageSettings(Me.mlng.Path, Me.lngFile)
        AddHandler Me.cadEditorControl.OptionsForm.ChangeLngPath, New ChangeLngPathEventHandler(AddressOf Me.ReloadLNG)
        AddHandler Me.cadEditorControl.OptionsForm.ChangeLanguage, New ChangeLanguageEventHandler(AddressOf Me.ChangeLanguage)
    End Sub

    Private Sub SetLNG()
        Me.mlng.LoadLNG(Me.lngFile)
        Me.mlng.RestoreLanguage(MyBase.Controls, MyBase.Menu)
        Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Clear()
        Me.mlng.LoadLngFileList(Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0), New EventHandler(AddressOf Me.LanguageSelect_Click))
        Me.Text = ApplicationConstants.appnamestr
        Me.Text = Me.mlng.SetLanguage(MyBase.Controls, MyBase.Menu, Me.Text)
        If (Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Count > Me.curLngIndex) Then
            Me.mainMenu.MenuItems.Item(4).MenuItems.Item(0).MenuItems.Item(Me.curLngIndex).Checked = True
        End If
    End Sub

    Friend Sub SetSettings()
        If (Not MainForm.settingsLst Is Nothing) Then
            Dim cn As Integer = 0
            Dim key As String = ApplicationConstants.languagepath
            If MainForm.settingsLst.ContainsKey(key) Then
                Me.mlng.Path = Convert.ToString(MainForm.settingsLst.Item(key))
            End If
            key = ApplicationConstants.languagestr
            If MainForm.settingsLst.ContainsKey(key) Then
                Me.lngFile = CStr(MainForm.settingsLst.Item(key))
            End If
            Me.mlng.LoadLNG(Me.lngFile)
            Me.Text = Me.mlng.SetLanguage(MyBase.Controls, MyBase.Menu, Me.Text)
            key = ApplicationConstants.languageIDstr
            If MainForm.settingsLst.ContainsKey(key) Then
                Me.curLngIndex = Convert.ToByte(MainForm.settingsLst.Item(key))
            End If
            key = ApplicationConstants.backcolorstr
            Dim tmp As String = ApplicationConstants.blackstr
            If MainForm.settingsLst.ContainsKey(key) Then
                tmp = Convert.ToString(MainForm.settingsLst.Item(key))
            End If
            If (tmp.ToUpper = ApplicationConstants.blackstr) Then
                Me.cadEditorControl.Black_Click()
            Else
                Me.cadEditorControl.White_Click()
            End If
            key = ApplicationConstants.showentitystr
            If MainForm.settingsLst.ContainsKey(key) Then
                tmp = Convert.ToString(MainForm.settingsLst.Item(key))
            End If
            If (tmp.ToUpper = ApplicationConstants.truestr) Then
                Me.cadEditorControl.EntityTreeVisible = True
            Else
                Me.cadEditorControl.EntityTreeVisible = False
            End If
            key = ApplicationConstants.drawmodestr
            If MainForm.settingsLst.ContainsKey(key) Then
                tmp = Convert.ToString(MainForm.settingsLst.Item(key))
            End If
            If (tmp.ToUpper = ApplicationConstants.truestr) Then
                Me.cadEditorControl.ColorDraw = True
            Else
                Me.cadEditorControl.ColorDraw = False
            End If
            key = ApplicationConstants.shxpathcnstr
            If MainForm.settingsLst.ContainsKey(key) Then
                cn = Convert.ToInt32(MainForm.settingsLst.Item(key))
            End If
            Dim i As Integer
            For i = 0 To cn - 1
                key = String.Format("SHXPath_{0}", (i + 1))
                If MainForm.settingsLst.ContainsKey(key) Then
                    Me.cadEditorControl.SHXForm.AddPath(Convert.ToString(MainForm.settingsLst.Item(key)))
                End If
            Next i
            key = ApplicationConstants.installstr
            If (MainForm.settingsLst.ContainsKey(key) AndAlso CADImport.CADConst.SearchSHXPaths) Then
                Me.cadEditorControl.SHXForm.lstDir.Items.Clear()
                Me.cadEditorControl.SHXForm.lstPath.Clear()
                Dim vPaths As New ArrayList
                CADImport.CADConst.FindAutoCADSHXPaths(vPaths)
                For i = 0 To vPaths.Count - 1
                    tmp = CStr(vPaths.Item(i))
                    Me.cadEditorControl.SHXForm.lstDir.Items.Add(tmp)
                    Me.cadEditorControl.SHXForm.lstPath.Add(tmp, String.Empty)
                    CADImport.CADConst.SHXSearchPaths = (CADImport.CADConst.SHXSearchPaths & CADImport.CADConst.SHXSearchPaths & tmp & ApplicationConstants.sepstr3)
                Next i
            End If
            key = ApplicationConstants.typelcstr
            If MainForm.settingsLst.ContainsKey(key) Then
                tmp = CStr(MainForm.settingsLst.Item(key))
                If (tmp = ApplicationConstants.floatingstr) Then
                    CADImport.Protection.LicenseType = CADImport.LicenseType.Floating
                    key = ApplicationConstants.hoststr
                    If MainForm.settingsLst.ContainsKey(key) Then
                        Me.cadEditorControl.FloatingRegistrationForm.Host = CStr(MainForm.settingsLst.Item(key))
                    End If
                    key = ApplicationConstants.portstr
                    If MainForm.settingsLst.ContainsKey(key) Then
                        Me.cadEditorControl.FloatingRegistrationForm.Port = Convert.ToInt32(MainForm.settingsLst.Item(key))
                    End If
                    key = ApplicationConstants.appconst
                    If MainForm.settingsLst.ContainsKey(key) Then
                        Me.cadEditorControl.FloatingRegistrationForm.App = CStr(MainForm.settingsLst.Item(key))
                    End If
                Else
                    CADImport.Protection.LicenseType = CADImport.LicenseType.Register
                End If
            End If
        End If
    End Sub


    ' Fields
    Private blackBackGround As Boolean
    Private cadEditorControl As cadEditorControl
    Private components As Container = Nothing
    Private curLngIndex As Integer
    Private dimVisible As Boolean
    Private editMenuItem As MenuItem
    Private Shared ReadOnly fileSettingsName As String = (Application.StartupPath & "\Settings.txt")
    Private lngFile As String
    Private mainMenu As mainMenu
    Private miAbout As MenuItem
    Private miArcsSplit As MenuItem
    Private miBlackBack As MenuItem
    Private miBlackMode As MenuItem
    Private miCADFiles As MenuItem
    Private miClose As MenuItem
    Private miColorMode As MenuItem
    Private miCopy As MenuItem
    Private miCopyAsBMP As MenuItem
    Private miCut As MenuItem
    Private miDelete As MenuItem
    Private miDimShow As MenuItem
    Private miExit As MenuItem
    Private miFile As MenuItem
    Private miFit As MenuItem
    Private miFloatLic As MenuItem
    Private miHelp As MenuItem
    Private miLayersShow As MenuItem
    Private miLng As MenuItem
    Private miOpenFile As MenuItem
    Private miPaste As MenuItem
    Private miPrint As MenuItem
    Private miPrintCustom As MenuItem
    Private miPrintPrev As MenuItem
    Private miRedo As MenuItem
    Private miRegister As MenuItem
    Private miSaveAsDXF As MenuItem
    Private miSaveFile As MenuItem
    Private miScale As MenuItem
    Private miSep As MenuItem
    Private miSep2 As MenuItem
    Private miSep3 As MenuItem
    Private miSep5 As MenuItem
    Private miShowEntitiesPanel As MenuItem
    Private miShowLineWeight As MenuItem
    Private miShowOptionsForm As MenuItem
    Private miShowSHXForm As MenuItem
    Private miTextsShow As MenuItem
    Private miUndo As MenuItem
    Private miView As MenuItem
    Private miWhiteBack As MenuItem
    Private miZoom10 As MenuItem
    Private miZoom100 As MenuItem
    Private miZoom200 As MenuItem
    Private miZoom25 As MenuItem
    Private miZoom400 As MenuItem
    Private miZoom50 As MenuItem
    Private miZoom800 As MenuItem
    Private miZoomIn As MenuItem
    Private miZoomOut As MenuItem
    Private mlng As MultipleLanguage
    Private mSep4 As MenuItem
    Private propPnVisible As Boolean
    Private Shared settingsLst As SortedList
    Private showLineWeight As Boolean
    Private svSet As SaveSettings
    Private textVisible As Boolean
    Private useWinEllipse As Boolean
    Private whiteBackGround As Boolean
End Class

Friend MustInherit Class ApplicationConstants
    ' Methods
    Protected Sub New()
    End Sub


    ' Fields
    Public Shared ReadOnly appconst As String = "Application"
    Public Shared ReadOnly appnamestr As String = "CADImportNet Demo"
    Public Shared ReadOnly backcolorstr As String = "BackgroundColor"
    Public Shared ReadOnly blackstr As String = "BLACK"
    Public Shared ReadOnly blackstr2 As String = "Black"
    Public Shared ReadOnly colorDraw As String = "ColorDraw"
    Public Shared ReadOnly colorstr As String = "Color"
    Public Shared ReadOnly defaultstr As String = "Default"
    Public Shared ReadOnly drawmodestr As String = "drawMode"
    Public Shared ReadOnly floatingstr As String = "floating"
    Public Shared ReadOnly freezestr As String = "Freeze"
    Public Shared ReadOnly hoststr As String = "Host"
    Public Shared ReadOnly installstr As String = "Install"
    Public Shared ReadOnly languageIDstr As String = "LanguageID"
    Public Shared ReadOnly languagepath As String = "LanguagePath"
    Public Shared ReadOnly languagestr As String = "Language"
    Public Shared ReadOnly lngextstr As String = ".lng"
    Public Shared ReadOnly msgBoxDebugCaption As String = "Debug application message"
    Public Shared ReadOnly namestr As String = "Name"
    Public Shared ReadOnly notsupportedextstr As String = "Not supported in current version!"
    Public Shared ReadOnly notsupportedstr As String = "not supported"
    Public Shared ReadOnly portstr As String = "Port"
    Public Shared ReadOnly registerstr As String = "register"
    Public Shared ReadOnly sepstr As String = " - "
    Public Shared ReadOnly sepstr2 As String = " : "
    Public Shared ReadOnly sepstr3 As String = ";"
    Public Shared ReadOnly showentitystr As String = "ShowEntity"
    Public Shared ReadOnly shxpathcnstr As String = "SHXPathCount"
    Public Shared ReadOnly truestr As String = "TRUE"
    Public Shared ReadOnly typelcstr As String = "Type_license"
    Public Shared ReadOnly visiblestr As String = "Visible"
    Public Shared ReadOnly whitestr As String = "White"
End Class


